#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define _GLIBCXX_DEBUG
vector<pair<ll, ll> > s;
vector<ll> m;
vector<ll> tree;

void update(int v, int vl, int vr, int i) {
    if (vl == vr - 1) {
        tree[v] = 0;
        return;
    }
    int mid = (vl + vr) / 2;
    if (mid > i) {
        update(2 * v, vl, mid, i);
    } else {
        update(2 * v + 1, mid, vr, i);
    }
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

void build(int v, int l, int r) {
    if (r == l + 1) {
        tree[v] = 1;
        return;
    }
    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid, r);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

ll get(int v, int l, int r, int i) {
    if (l == r - 1) {
        return l;
    }
    int mid = (l + r) / 2;
    if (tree[2 * v] <= i) {
        i -= tree[2 * v];
        return get(2 * v + 1, mid, r, i);
    } else {
        return get(2 * v, l, mid, i);
    }
}


signed main() {
    int n;
    cin >> n;
    vector<ll> h(n);
    vector<ll> pref(n + 1);
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        pref[i + 1] = pref[i] + h[i];
    }
    vector<int> l(n, -1);
    vector<int> r(n, n);
    deque<int> q;
    for (int i = 0; i < n; i++) {
        while (!q.empty()){
            if (h[q.back()] < h[i]) {
                q.pop_back();
            } else {
                break;
            }
        }
        if (!q.empty()) {
            l[i] = q.back();
        }
        q.push_back(i);
    }
    q.clear();
    for (int i = n - 1; i >= 0; i--) {
        while (!q.empty()){
            if (h[q.front()] < h[i]) {
                q.pop_front();
            } else {
                break;
            }
        }
        if (!q.empty()) {
            r[i] = q.front();
        }
        q.push_front(i);
    }
    s.resize(n);
    m = h;
    tree.resize(4 * n);
    vector<pair<int, int> > w(n);
    for (int i = 0; i < n; i++) {
        w[i] = {i, h[i]};
    }
    build(1, 0, n);
    vector<pair<int, int> > v(n, {0, 0});
    for (int i = 0; i < n; i++) {
        s[i] = {i, i + 1};
    }
    for (int _ = 0; _ < n - 1; _++) {
        int k;
        cin >> k;
        k--;
        int i = get(1, 0, n, k);
        int j = get(1, 0, n, k + 1);
        update(1, 0, n, j);
        int x = w[i].second;
        int y = w[j].second;
        int L = l[w[j].first];
        int R = r[w[i].first];
        ll k1;
        if (x < y) {
            k1 = x * (R - w[i].first - 1) - (pref[R] - pref[w[i].first + 1]);
        } else {
            k1 = y * (w[j].first - L - 1) - (pref[w[j].first] - pref[L + 1]);
        }
        cout << v[i].first + v[j].second + k1 << endl;
        v[i].second = v[j].second;
        if (x > y) {
            v[i].second += k1;
            w[j] = w[i];
        } else {
            v[i].first += k1;
            w[i] = w[j];
        }
    }
    return 0;
}

