#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define _GLIBCXX_DEBUG
vector<pair<ll, ll> > s;
vector<ll> m;
vector<ll> tree;

void update(int v, int vl, int vr, int i) {
    if (vl == vr - 1) {
        tree[v] = 0;
        return;
    }
    int mid = (vl + vr) / 2;
    if (mid > i) {
        update(2 * v, vl, mid, i);
    } else {
        update(2 * v + 1, mid, vr, i);
    }
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

void build(int v, int l, int r) {
    if (r == l + 1) {
        tree[v] = 1;
        return;
    }
    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid, r);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

ll get(int v, int l, int r, int i) {
    if (l == r - 1) {
        return l;
    }
    int mid = (l + r) / 2;
    if (tree[2 * v] <= i) {
        i -= tree[2 * v];
        return get(2 * v + 1, mid, r, i);
    } else {
        return get(2 * v, l, mid, i);
    }
}


signed main() {
    int n;
    cin >> n;
    vector<ll> h(n);
    vector<ll> pref(n + 1);
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        pref[i + 1] = pref[i] + h[i];
    }
    tree.resize(4 * n);
    vector<pair<int, int> > w(n);
    for (int i = 0; i < n; i++) {
        w[i] = {i, i + 1};
    }
    build(1, 0, n);
    vector<int> que(n - 1);
    int g = 0;
    for (int _ = 0; _ < n - 1; _++) {
        int k;
        cin >> k;
        k--;
        que[_] = k;
        if (k == 1) {
            g++;
        }
    }
    if (g != n - 1) {
        for (auto k : que) {
            ll i = get(1, 0, n, k);
            ll j = get(1, 0, n, k + 1);
            ll l = w[i].first;
            ll r = w[j].second;
            w[i] = {l, r};
            update(1, 0, n, j);
            multiset<int> s1;
            multiset<int> s2;
            for (int k = l; k < r; k++) {
                s1.insert(h[k]);
            }
            ll ans = 0;
            for (int k = l; k < r; k++) {
                s2.insert(h[k]);
                ans += min(*s1.rbegin(), *s2.rbegin()) - h[k];
                s1.erase(s1.find(h[k]));
            }
            cout << ans << endl;
        }
        return 0;
    } else {
        vector<int> l(n);
        deque<int> q;
        for (int i = 0; i < n; i++) {
            while (!q.empty()){
                if (h[q.back()] < h[i]) {
                    q.pop_back();
                } else {
                    break;
                }
            }
            if (!q.empty()) {
                l[i] = q.back();
            }
            q.push_back(i);
        }
        vector<int> dp(n);
        dp[0] = 0;
        for (int k = 1; k < n; k++) {
            ll i = 0;
            ll j = k;
            int L = l[h[j]];
            dp[k] = dp[L] + h[j] * (j - L) - pref[j - 1] + pref[L];
            cout << dp[k];
        }
    }
    return 0;
}

